#ifndef Time_h
#define Time_h

struct Time
{
        long unixdate;

	Time();
	Time( long x ) { unixdate = x; }

	long Second() const;
	long Minute() const;
	long Hour() const;
	long Day() const;
	long Month() const;
	long Year() const;
	long Clock() const { return unixdate; }
};

class standardout;
long operator - ( Time a, Time b );
Time operator + ( Time a, long b );
inline int operator == ( Time a, Time b ) { return a.unixdate == b.unixdate; }
inline int operator != ( Time a, Time b ) { return a.unixdate != b.unixdate; }
inline int operator < ( Time a, Time b ) { return a.unixdate < b.unixdate; }
inline int operator > ( Time a, Time b ) { return a.unixdate > b.unixdate; }
inline int operator <= ( Time a, Time b ) { return a.unixdate <= b.unixdate; }
inline int operator >= ( Time a, Time b ) { return a.unixdate >= b.unixdate; }
Time DateOnly( Time x );
standardout& operator << ( standardout& out, Time x );
const char * DateDisplay( Time t );

extern Time Today, Now;

#endif
