#pragma hdrstop
#include <conio.h>
#include <stdlib.h>

#include "srinout.h"

const char ColorKey = 18;       // ^R = color change key

extern "C"	{
	char *strcpy( char *, const char * );
}

int ChatMode()
{
        static int inchat = 0;

	char oldline[256];
        int     cattr[10] = { 0x04, 0x07, 0x08, 0x0E, 0x05, 0x03, 0x0F, 0x0C, 0x09, 0x0B };
        int     userflag = 1,
		userkeyboard = 1,
                userattr = 14,
                sysopattr = 11,
		userPflag = 0,
		sysopPflag = 0;
	int ch;
        char c;

        if( inchat )    return 1;

        inchat = 1;

        if( ComPort == 0 )
                return 1;

	// First save line
	strcpy( oldline, kout.buffer() );

	// Go to next line and enter chat mode
        kout << '\n' << attr(15) << "Chat mode:  " << attr(3) << "CONTROL-Z to exit\nCONTROL-R + a number to change colors\n" << attr(BC);

	do	{
                if( kin.keyhit() )      {
                        kin >> c;
                        ch = (unsigned char)c;
                }
                else    {
                        ch = 0;
                        kout << "_\b";
                }

                if( ch != 0 && LastRead == Modem )   {
			if( !userflag )
				kout << attr( userattr & 0x0f, userattr >> 4 );
			userflag = 1;
			if( userkeyboard && ch > 0 && !userPflag )	{
				if( ch == '\r' )
					ch = '\n';
				if( ch == ColorKey )
					userPflag = 1;
				else
					kout << (char)(ch & 0xff);
				if( ch == '\b' )
					kout << " \b";
			}
			else if( userPflag )	{
				userPflag = 0;
                                userflag = 0;
                                if( ch >= '0' && ch <= '9' )
					userattr = cattr[ch-'0'];
			}
		}
                else if( ch != 0 && LastRead == Keyboard )      {
                        if( ch == 0 )   {
                                kin >> c;
                                ch = (int)256 * (unsigned char)c;
                        }
                        if( ch == ( 61 << 8 ) ) {
				int x, y;

				userkeyboard = !userkeyboard;
				x = wherex();
				y = wherey();
				gotoxy( 1, 1 );

				cprintf( "User keyboard status:  %d        \n", userkeyboard );
				gotoxy( x, y );
			}
			if( userflag )
				kout << attr( sysopattr & 0x0f, sysopattr >> 4 );
			userflag = 0;
                        if( ch > 0 && ch < 256 && !sysopPflag )     {
				if( ch == '\r' )
					ch = '\n';
				if( ch == ColorKey )
					sysopPflag = 1;
				else
					kout << (char)(ch & 0xff);
				if( ch == '\b' )
					kout << " \b";
			}
                        else if( sysopPflag )   {
				sysopPflag = 0;
                                userflag = 1;
				if( ch >= '0' && ch <= '9' )
					sysopattr = cattr[ch-'0'];
			}
		}
	} while( ch != 27 && ch != 26 );

	kout << attr(15) << "\nChat mode ended.\n" << attr() << oldline;
        inchat = 0;
	return 0;
}

