#ifndef PARAM_H
#define PARAM_H

class Resource
{
	static int dirty;
	static Resource *head;
	Resource *next;

	const char *name;
	char *value;
	int initialized;

        void CC set( const char *newvalue );

        static void Read( const char *name );
	static void Read();

public:
	Resource( const char *s, const char *default_value = 0 );
	Resource( const char *s, const long default_value = 0 );

	~Resource();

	CC operator const char *();

	long CC Long();
	int CC Boolean();
};

int CC Parameter( const char *s );

#endif	PARAM_H
