void localstatusbar( char *username, int com, int baud, char *VERSION );

extern int FAST_WRITE;

class ansiout
{
private:	
	char str[80];	// stores ANSI escape sequence
	int 	savex,
		savey;	// saved cursor position
	unsigned col;	// text attribute;
	int str_len, interpretpos;
	unsigned char LastMode, Height, Width;

	int p, x, y;

        int getx();
        int gety();
        void gotoxy( int x, int y );
        void clrscr( int y1 = -1, int y2 = -1 );

	char tty( char ch );
	void tabulate(void);
	void backspace(void);
	void ANSIwrite( char *s );
	int param(void);

        friend void ansi_init();

public:
	ansiout();
	~ansiout();

	int put( char ch );
};

extern ansiout aout;

extern int MINY;
extern int MAXY;
