#ifndef number_h
#define number_h

#ifdef QUAD

#include <quad.h>
typedef quad number;
extern "C" void quad2asc(const unsigned long*,char*);
inline void number2ascii(number x,char *s) { quad2asc((const unsigned long *)&x,s); }
inline long number2long(number x) { return x.Long(); }

#else

typedef long number;
extern "C" char* ltoa(long,char*,int);
inline void number2ascii(number x,char *s) { ltoa(x,s,10); }
inline long number2long(number x) { return x; }

#endif

#endif
