#ifndef TYPES_H
#define TYPES_H

#include <datetime.h>

const long DAYS = 86400L;
const long HOURS = 3600L;
const long MINUTES = 60L;
const long SECONDS = 1L;
const long WEEKS = (DAYS*7L);
const long YEARS = (DAYS*365L);

typedef int Bool;
const Bool TRUE = 1;
const Bool FALSE = 0;

typedef int ID;
const ID NoID = -1;

typedef unsigned char byte;
typedef unsigned word;
typedef char shortint;

#define self (*this)

#endif  TYPES_H

